Software/KPICore/Components/Shared/DashboardSelectorViewComponent.cs
using AEWeb.ViewModels.Dashboard;
using Domain.Indicators;
using Domain.Security;
using Infrastructure.Mediator.Indicator.Queries;
using KPIClassLibrary.KPI;
using MediatR;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace AEWeb.Components.Shared
{
    public class DashboardSelectorViewComponent : ViewComponent
    {
        private readonly UserManager<ApplicationUser> _userManager;
        private ILogger<DashboardSelectorViewComponent> _logger;
        private IMediator _mediator;

        public DashboardSelectorViewComponent(UserManager<ApplicationUser> userManager,
            ILogger<DashboardSelectorViewComponent> logger,
            IMediator mediator)
        {
            _userManager = userManager;
            _mediator = mediator;
            _logger = logger;
        }
        public async Task<IViewComponentResult> InvokeAsync()
        {
            var user = await _userManager.FindByNameAsync(User.Identity.Name);
            DomainUser domain = await _mediator.Send(new GetDomainUser() { UserId = user.Id });
            DashboardSelectorViewModel model = new DashboardSelectorViewModel();
            model.userid = user.Id;
            model.domain = domain.Domain.Value;

            return View("Default", model);
        }
    }
}

Software/KPICore/Components/Shared/MessagesViewComponent.cs
using Infrastructure.ViewModels.Shared;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;

namespace AEWeb.Components.Shared
{
    public class MessagesViewComponent : ViewComponent
    {
        public IViewComponentResult Invoke()
        {
            MessagesViewModel messages;
            if (TempData["Messages"] is string s)
            {
                messages = JsonConvert.DeserializeObject<MessagesViewModel>(s);
            }
            else
                messages = new MessagesViewModel();

            return View("Default", messages);
        }
    }
}

Software/KPICore/Components/Shared/NavigationMenuViewComponent.cs
using Domain.Security;
using AEWeb.ViewModels.Menu;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Identity;
using Microsoft.IdentityModel.Clients.ActiveDirectory;
using KPIClassLibrary.KPI;
using MediatR;
using Infrastructure.Mediator.Indicator.Queries;
using Domain.Indicators;
using Infrastructure.Mediator.Indicator.Commands;
using Microsoft.Extensions.Localization;
using Infrastructure.ViewModels.Shared;

namespace AEWeb.Components.Shared
{
    public class NavigationMenuViewComponent : ViewComponent
    {
        private readonly IAuthorizationService _authorization;
        private readonly UserManager<ApplicationUser> _userManager;
        private readonly IWebHostEnvironment _hostingEnvironment;
        private readonly IMediator _mediator;
        private readonly ILogger<NavigationMenuViewComponent> _logger;
        private IStringLocalizer<SharedResources> _localizer;

        public NavigationMenuViewComponent(
            IAuthorizationService authorization,
            IWebHostEnvironment hostingEnvironment,
            ILogger<NavigationMenuViewComponent> logger,
            UserManager<ApplicationUser> userManager,
            IMediator mediator,
            IStringLocalizer<SharedResources> localizer)
        {
            _authorization = authorization;
            _hostingEnvironment = hostingEnvironment;
            _logger = logger;
            _userManager = userManager;
            _mediator = mediator;
            _localizer = localizer;
        }
        public async Task<IViewComponentResult> InvokeAsync(string nothing)
        {
            _logger.LogInformation("Showing the navigation menu");

            ApplicationUser user = await _userManager.FindByNameAsync(User.Identity.Name);

            NavigationMenuViewModel theMenu = new NavigationMenuViewModel();
            theMenu.Username = user.FullName;
            string contentRootPath = _hostingEnvironment.ContentRootPath;
            string menusJson = "";
            try
            {
                menusJson = System.IO.File.ReadAllText(contentRootPath + "/DataFiles/menu.json");
                _logger.LogDebug("The file with the menu configuration has been read: " + menusJson.Length + " chars");
            }
            catch (Exception q)
            {
                _logger.LogError("The menu configuration couldnot be loaded, maybe missing file or malformed", q);
            }

            dynamic menusJsonObject = JsonConvert.DeserializeObject(menusJson);

            await ReadMenuItems(theMenu, menusJsonObject);

            await ReadDomainForUser(theMenu, user.Id);

            ReadConfiguredDomains(theMenu);

            return View("Default", theMenu);
        }

        private void ReadConfiguredDomains(NavigationMenuViewModel theMenu)
        {
            theMenu.DomainsConfigured.Clear();
            string[] domains = Enum.GetNames(typeof(KPIDomain));
            foreach(string aDomain in domains)
            {
                theMenu.DomainsConfigured.Add(new ListItemViewModel() { 
                    Text = _localizer[aDomain], 
                    Value = aDomain 
                });
            }
        }

        private async Task<NavigationMenuViewModel> ReadDomainForUser(NavigationMenuViewModel theMenu, string userid)
        {
            DomainUser domainUser = await _mediator.Send(new GetDomainUser() { UserId = userid });
            KPIDomain theDomain = KPIDomain.Tax;
            
            if (domainUser != null && !string.IsNullOrWhiteSpace(domainUser.Domain))
            {
                theDomain = (KPIDomain)(Enum.Parse(typeof(KPIDomain), domainUser.Domain));
            }
            else 
            {
                domainUser = await _mediator.Send(new CreateUpdateDomainUserCommand()
                {
                    Domain = theDomain.ToString(),
                    UserId = userid
                }) ;
            }

            theMenu.Domain = theDomain;

            return theMenu;
        }

        private async Task<NavigationMenuViewModel> ReadMenuItems(NavigationMenuViewModel theMenu,
            dynamic submenus)
        {
            if (submenus == null)
                return theMenu;

            List<NavigationMenuViewModel> menus = new List<NavigationMenuViewModel>();
            foreach (var objMenu in submenus)
            {
                string policy = objMenu.claim;
                bool isAllowedToViewMenu = false;
                if (policy.Equals("NONE"))
                    isAllowedToViewMenu = true;
                else
                {
                    AuthorizationResult allowed = await _authorization.AuthorizeAsync(UserClaimsPrincipal, policy);
                    isAllowedToViewMenu = allowed.Succeeded;
                }
                if (isAllowedToViewMenu)
                {
                    NavigationMenuViewModel newMenu = new NavigationMenuViewModel();
                    newMenu.Action = objMenu.action;
                    newMenu.Controller = objMenu.controller;
                    newMenu.Url = objMenu.url;
                    newMenu.ResourceItem = objMenu.resourceItem;
                    newMenu.Icon = objMenu.icon;
                    newMenu.Menu = objMenu.menu;
                    ReadMenuItems(newMenu, objMenu.submenus);
                    menus.Add(newMenu);
                    _logger.LogDebug("Adding menu " + newMenu.Menu);
                }
            }
            theMenu.Submenus = menus;

            return theMenu;
        }
    }
}

Software/KPICore/Controllers/Shared/I18nController.cs
using Microsoft.AspNetCore.Localization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Filters;
using System;
using System.Globalization;

namespace AEWeb.Controllers.Shared
{
    public abstract class I18nController : Controller
    {
        /// <summary>
        /// This is called before the action method is invoked, but this belongs to ControllerBase
        /// </summary>
        /// <param name="context"></param>
        public override void OnActionExecuting(ActionExecutingContext context)
        {
            if (!string.IsNullOrEmpty(context.HttpContext.Request.Query["culture"]))
            {
                Response.Cookies.Append(
                    CookieRequestCultureProvider.DefaultCookieName,
                    CookieRequestCultureProvider.MakeCookieValue(new RequestCulture(context.HttpContext.Request.Query["culture"])),
                    new Microsoft.AspNetCore.Http.CookieOptions { Expires = DateTimeOffset.UtcNow.AddYears(1) }
                    );
            }
            var locale = Request.HttpContext.Features.Get<IRequestCultureFeature>();

            base.OnActionExecuting(context);
        }
    }
}

Software/KPICore/Controllers/Shared/MessagesController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;

namespace AEWeb.Controllers.Shared
{
    public class MessagesController : Controller
    {
        public void LoadMessages()
        {
            
        }
    }
}

Software/KPICore/Views/Shared/_DashboardLayout.cshtml
@addTagHelper *, AEWeb
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"]</title>
    <meta http-equiv="X-UA-Compatible" content="IE=edge">

    <!-- Add local styles, mostly for plugins css file -->
    <style>
        .ibox-title {
            padding-right: 20px !important;
        }
    </style>
    @if (IsSectionDefined("Styles"))
    {@RenderSection("Styles", required: false)}

<environment names="Development">
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.css" />
    <link href="~/lib/kendo-ui/styles/kendo.bootstrap-v4.min.css" rel="stylesheet" />
    <link rel="stylesheet" href="~/lib/font-awesome/css/font-awesome.css" />
    <link rel="stylesheet" href="~/css/animate.css" />
    <link rel="stylesheet" href="~/css/style.css" asp-append-version="true" />

    <link rel="stylesheet" href="~/lib/gridstack/dist/demo.css" />

    <script type="module" src="https://unpkg.com/ionicons@4.5.10-0/dist/ionicons/ionicons.esm.js"></script>
    <script nomodule="" src="https://unpkg.com/ionicons@4.5.10-0/dist/ionicons/ionicons.js"></script>

    <script src="~/lib/jquery/dist/jquery.js"></script>
    <script src="~/lib/kendo-ui/js/kendo.all.min.js"></script>
    <script src="~/lib/kendo-ui/js/kendo.aspnetmvc.min.js"></script>

    <script src="~/lib/gridstack/dist/gridstack.js"></script>
    <script src="~/lib/jquery-ui/jquery-ui.js"></script>
    <script src="~/lib/gridstack/dist/gridstack.jQueryUI.js"></script>

    <script src="https://code.highcharts.com/highcharts.js"></script>
    <script src="https://code.highcharts.com/modules/exporting.js"></script>
    <script src="https://code.highcharts.com/modules/export-data.js"></script>
    <script src="https://code.highcharts.com/modules/accessibility.js"></script>
</environment>
<environment names="Staging,Production">
    <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.css" />
    <link href="~/lib/kendo-ui/styles/kendo.bootstrap-v4.min.css" rel="stylesheet" />
    <link rel="stylesheet" href="~/lib/font-awesome/css/font-awesome.css" />
    <link rel="stylesheet" href="~/css/animate.css" />
    <link rel="stylesheet" href="~/css/style.css" asp-append-version="true" />

    <link rel="stylesheet" href="~/lib/gridstack/dist/demo.css" />

    <script type="module" src="https://unpkg.com/ionicons@4.5.10-0/dist/ionicons/ionicons.esm.js"></script>
    <script nomodule="" src="https://unpkg.com/ionicons@4.5.10-0/dist/ionicons/ionicons.js"></script>

    <script src="~/lib/jquery/dist/jquery.js"></script>
    <script src="~/lib/kendo-ui/js/kendo.all.min.js"></script>
    <script src="~/lib/kendo-ui/js/kendo.aspnetmvc.min.js"></script>

    <script src="~/lib/gridstack/dist/gridstack.js"></script>
    <script src="~/lib/jquery-ui/jquery-ui.js"></script>
    <script src="~/lib/gridstack/dist/gridstack.jQueryUI.js"></script>

    <script src="https://code.highcharts.com/highcharts.js"></script>
    <script src="https://code.highcharts.com/modules/exporting.js"></script>
    <script src="https://code.highcharts.com/modules/export-data.js"></script>
    <script src="https://code.highcharts.com/modules/accessibility.js"></script>
</environment>


</head>
<body class="skin-1">

    <!-- Wrapper-->
    <div id="wrapper" class="@Html.PageClass()">

        <!-- Navigation <partial name="_Navigation" />-->
        <vc:navigation-menu nothing=""></vc:navigation-menu>

        <!-- Page wraper -->
        <div id="page-wrapper" class="gray-bg @ViewBag.SpecialClass">

            <!-- Top Navbar -->
            <partial name="_TopNavbar" />

            <!-- Main view  -->
            @RenderBody()

            <!-- Footer -->
            <partial name="_Footer" />

        </div>
        <!-- End page wrapper-->

    </div>
    <!-- End wrapper-->

    <environment names="Development">
        <script src="~/lib/Popper/popper.min.js"></script>
        <script src="~/lib/bootstrap/dist/js/bootstrap.js"></script>
        <script src="~/lib/metisMenu/dist/jquery.metisMenu.js"></script>
        <script src="~/lib/slimScroll/jquery.slimscroll.js"></script>
        <script src="~/lib/pace/pace.js"></script>
        <script src="~/js/script.js" asp-append-version="true"></script>

        <!-- Only for demo purpose -->
        <script src="~/js/skin.config.js"></script>
    </environment>
    <environment names="Staging,Production">
        <script src="~/lib/Popper/popper.min.js"></script>
        <script src="~/lib/bootstrap/dist/js/bootstrap.min.js"></script>
        <script src="~/lib/metisMenu/dist/jquery.metisMenu.js"></script>
        <script src="~/lib/pace/pace.min.js"></script>
        <script src="~/lib/slimScroll/jquery.slimscroll.min.js"></script>
        <script src="~/js/script.js" asp-append-version="true"></script>
    </environment>

    @RenderSection("scripts", required: false)
</body>
</html>

Software/KPICore/Views/Shared/_Footer.cshtml
<div class="footer">
    <div class="float-right">
        A TAX DIAMOND tool
    </div>
    <div>
        <strong>Copyright</strong> &copy; 2020
    </div>
</div>

Software/KPICore/Views/Shared/_Language.cshtml
@using Microsoft.AspNetCore.Mvc.Localization
@inject IViewLocalizer Localizer
<div class="dropdown-header bg-trans-gradient d-flex justify-content-center align-items-center rounded-top mb-2">
    <h4 class="m-0 text-center color-white">
        @Localizer["LblLanguage"]
    </h4>
</div>

<div class="dropdown-divider m-0"></div>
<a href="/Home/Main?culture=en-US" class="dropdown-item fw-500 pt-3 pb-3"><span>@Localizer["LblEn"]</span></a>
<a href="/Home/Main?culture=ru-RU" class="dropdown-item fw-500 pt-3 pb-3"><span>@Localizer["LblRu"]</span></a>

Software/KPICore/Views/Shared/_Layout.cshtml
@addTagHelper *, AEWeb
@{
    var culture = System.Globalization.CultureInfo.CurrentCulture.ToString();
    var kendojs = culture + ".min.js";
}
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - Monitoring Tool</title>
    <meta http-equiv="X-UA-Compatible" content="IE=edge">

    <environment names="Development">
        <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.css" />
        <link href="~/lib/kendo-ui/styles/kendo.bootstrap-v4.min.css" rel="stylesheet" />
        <link rel="stylesheet" href="~/lib/font-awesome/css/font-awesome.css" />
        <link rel="stylesheet" href="~/css/animate.css" />
        <link rel="stylesheet" href="~/css/style.css" asp-append-version="true" />
        <link rel="stylesheet" href="~/lib/toastr/toastr.css" />

        <script src="~/lib/jquery/dist/jquery.js"></script>
        <script src="~/lib/kendo-ui/js/kendo.all.min.js"></script>
        <script src="~/lib/kendo-ui/js/kendo.aspnetmvc.min.js"></script>
        <script src="~/lib/kendo-ui/js/cultures/kendo.culture.@kendojs"></script>
    </environment>
    <environment names="Staging,Production">
        <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.min.css" />
        <link href="~/lib/kendo-ui/styles/kendo.bootstrap-v4.min.css" rel="stylesheet" />
        <link rel="stylesheet" href="~/lib/font-awesome/css/font-awesome.min.css" />
        <link rel="stylesheet" href="~/css/animate.css" />
        <link rel="stylesheet" href="~/css/style.css" asp-append-version="true" />
        <link rel="stylesheet" href="~/lib/toastr/toastr.min.css" />

        <script src="~/lib/jquery/dist/jquery.js"></script>
        <script src="~/lib/kendo-ui/js/kendo.all.min.js"></script>
        <script src="~/lib/kendo-ui/js/kendo.aspnetmvc.min.js"></script>
        <script src="~/lib/kendo-ui/js/cultures/kendo.culture.@kendojs"></script>
    </environment>
    <script type="text/javascript">
        //set culture of the Kendo UI
        kendo.culture("@culture");
    </script>
    <!-- Add local styles, mostly for plugins css file -->
    @if (IsSectionDefined("Styles"))
    {@RenderSection("Styles", required: false)}

</head>
<body class="skin-1">

    <!-- Wrapper-->
    <div id="wrapper" class="@Html.PageClass()">

        <!-- Navigation <partial name="_Navigation" />-->
        <vc:navigation-menu nothing=""></vc:navigation-menu>

        <!-- Page wraper -->
        <div id="page-wrapper" class="gray-bg @ViewBag.SpecialClass">

            <!-- Top Navbar -->
            <partial name="_TopNavbar" />

            <!-- Main view  -->
            @RenderBody()

            <!-- Footer -->
            <partial name="_Footer" />

        </div>
        <!-- End page wrapper-->

    </div>
    <!-- End wrapper-->

    <environment names="Development">

        <script src="~/lib/Popper/popper.min.js"></script>
        <script src="~/lib/bootstrap/dist/js/bootstrap.js"></script>
        <script src="~/lib/metisMenu/dist/jquery.metisMenu.js"></script>
        <script src="~/lib/slimScroll/jquery.slimscroll.js"></script>
        <script src="~/lib/pace/pace.js"></script>
        <script src="~/js/script.js" asp-append-version="true"></script>
        <script src="~/lib/toastr/toastr.js"></script>
        <!-- Only for demo purpose -->
        <script src="~/js/skin.config.js"></script>
    </environment>
    <environment names="Staging,Production">

        <script src="~/lib/Popper/popper.min.js"></script>
        <script src="~/lib/bootstrap/dist/js/bootstrap.min.js"></script>
        <script src="~/lib/metisMenu/dist/jquery.metisMenu.js"></script>
        <script src="~/lib/pace/pace.min.js"></script>
        <script src="~/lib/slimScroll/jquery.slimscroll.min.js"></script>
        <script src="~/js/script.js" asp-append-version="true"></script>
        <script src="~/lib/toastr/toastr.min.js"></script>
    </environment>

    @RenderSection("scripts", required: false)
</body>
</html>

Software/KPICore/Views/Shared/_Navigation.cshtml
@using Microsoft.AspNetCore.Mvc.Localization
@inject IViewLocalizer Localizer
@{
    var culture = System.Globalization.CultureInfo.CurrentCulture.ToString();
}

<nav class="navbar-default navbar-static-side" role="navigation">
    <div class="sidebar-collapse">
        <ul class="nav metismenu" id="side-menu">
            <li class="nav-header">
                <div class="dropdown profile-element">
                    <a data-toggle="dropdown" class="dropdown-toggle" href="#">
                        <span class="block m-t-xs font-bold">Username</span>
                        <span class="text-muted text-xs block">Title <b class="caret"></b></span>
                    </a>
                    <ul class="dropdown-menu animated fadeInRight m-t-xs" style="position: absolute; top: 91px; left: 0px; will-change: top, left;">
                        <li><a class="dropdown-item" href="@Url.Action("Logout","Security")">@Localizer["LogoutLbl"]</a></li>
                    </ul>
                </div>
                <div class="logo-element">
                    IN+
                </div>
            </li>
            <li class="@Html.IsSelected(controller: "Home", action: "Main")">
                <a href="@Url.Action("Main", "Home")"><i class="fa fa-diamond"></i> <span class="nav-label">Main</span> <span class="label label-primary float-right">Main</span></a>
            </li>
            <li class="@Html.IsSelected(controller: "Home", action: "Minor")">
                <a href="@Url.Action("Minor", "Home")"><i class="fa fa-server"></i> <span class="nav-label">Minor</span></a>
            </li>
        </ul>
    </div>
</nav>

Software/KPICore/Views/Shared/_TopNavbar.cshtml
@addTagHelper *, AEWeb
@using Microsoft.AspNetCore.Mvc.Localization
@inject IViewLocalizer Localizer
@{
    var culture = System.Globalization.CultureInfo.CurrentCulture.ToString();
}

<div class="row border-bottom">
    <nav class="navbar navbar-static-top white-bg" role="navigation" style="margin-bottom: 0">
        <div class="navbar-header">
            <a class="navbar-minimalize minimalize-styl-2 btn btn-primary " href="#"><i class="fa fa-bars"></i> </a>
            <vc:dashboard-selector></vc:dashboard-selector>
        </div>
        <ul class="nav navbar-top-links navbar-right">
            <li style="padding:20px">
                <span class="m-r-sm text-muted welcome-message">
                    @Localizer["WelcomeToLbl"] @Localizer["ApplicationName"]
                </span>
            </li>
            <li>
                <a href="#" class="header-icon" data-toggle="dropdown">
                    <i class="fa fa-globe"></i>
                </a>
                <div class="dropdown-menu dropdown-menu-animated dropdown-lg">
                    <partial name="_Language" />
                </div>
            </li>
            <li>
                <vc:messages></vc:messages>
            </li>
            <li>
                <a href="@Url.Action("Logout","Security")">
                    <i class="fa fa-sign-out"></i> @Localizer["LogoutLbl"]
                </a>
            </li>
        </ul>
    </nav>
</div>